<?php
 namespace imwpf\modules; class Form { protected $form = array(); protected $formID; protected $currentInputIndex = -1; protected $input = array(); private $_minHeight = ""; private $showCondition = array(); public function __construct($ = 'POST', $ = '', $ = '提交') { $this->form = array('method' => $, 'action' => $, 'data' => &$this->input, 'submit' => $); $this->formID = $this->createId(); } public function minHeight($) { $this->_minHeight = $; } public static function createId() { $ = 0; $ = ''; while ($ < 5) { $ .= chr(mt_rand(97, 122)); $++; } return $; } public function createScript() { $ = file_get_contents(dirname(__DIR__) . "/views/form.css"); $ = file_get_contents(dirname(__DIR__) . "/views/form.min.js"); $ .= file_get_contents(dirname(__DIR__) . "/views/ajaxupload.min.js"); ?>
        <style type="text/css">
            <?php  echo $; ?>
        </style>

        <script type="text/javascript">
            <?php  echo $; ?>
            var g_retry = 0;
            //加号按钮效
            jQuery(document).ready(function($) {
                $('#<?php  echo $this->formID; ?>').delegate('.add', 'click', function() {
                    var currentIndex = $(this).attr("data-index") || 0;
                    var input = $(this).parent().find("input, div").first();
                    var html = input.prop("outerHTML");
                    newinput = html + '<span class="minus">-</span>';
                    //追加新的标签
                    $(this).before($(newinput));
                });

                //减号按钮效果
                $('#<?php  echo $this->formID; ?>').delegate('.minus', 'click', function() {
                    // $(this).prev().prev().remove();
                    $(this).prev().remove();
                    $(this).remove();
                });

                // ajax 上传
                $('.imwpf_image_upload_button').each(function() {
                    var clickedObject = $(this);
                    var buttonID = $(this).attr('id');
                    var fileID = $(this).attr("file-id");
                    var buttonText = $(this).text();
                    var nonce = $('#security').val();
                    var uploadDir = $(this).attr("data-upload-dir") || "";
                    new AjaxUpload(buttonID, {
                        action: ajaxurl,
                        name: fileID, // File upload name
                        data: {
                            action: 'imwpf_upload',
                            type: 'upload',
                            security: nonce,
                            data: fileID,
                            upload_dir: uploadDir,
                        },
                        autoSubmit: true, // Submit file after selection
                        responseType: false,
                        onChange: function(file, extension) {},
                        onSubmit: function(file, extension) {
                            clickedObject.text('上传中.'); // change button text, when user selects file   
                            this.disable(); // If you want to allow uploading only 1 file at time, you can disable upload button
                            interval = window.setInterval(function() {
                                var text = clickedObject.text();
                                if (text.length < 13) {
                                    clickedObject.text(text + '.');
                                } else {
                                    clickedObject.text('上传中.');
                                }
                            }, 200);
                        },
                        onComplete: function(file, response) {
                            response = JSON.parse(response)
                            window.clearInterval(interval);
                            clickedObject.text(buttonText);
                            this.enable(); // enable upload button
                            // If nonce fails
                            if (response.errno != 0) {
                                alert("上传失败，原因: " + response.msg)
                            } else {
                                var buildReturn = "";
                                if (response.data.type.indexOf("image") != -1) {
                                    buildReturn = '<img class="uploaded-image" id="image_' + fileID + '" src="' + response.data.url + '" />';
                                } else {
                                    buildReturn = '<p>文件已上传至 ' + response.data.path + '</p>';
                                }

                                $(".upload-error").remove();
                                $("#image_" + fileID).remove();
                                console.log(buildReturn);
                                clickedObject.parent().after(buildReturn);
                                $('#image_' + fileID).fadeIn();
                                $("#" + fileID + "_upload").val(response.data.url);
                                $("#" + fileID + "_upload_path").val(response.data.path);
                                $("#" + fileID + "_upload_id").val(response.data.id);
                                clickedObject.next('span').fadeIn();
                                // console.log(clickedID + "_upload");
                            }
                        }
                    });
                });

                // 移除图片
                $('.imwpf_image_reset_button').click(function() {
                    var theID = $(this).attr('title');
                    var image_to_remove = $('#image_' + theID);
                    var button_to_hide = $('#reset_' + theID);
                    image_to_remove.fadeOut(500, function() {
                        $(this).remove();
                    });
                    button_to_hide.fadeOut();
                    $("#" + theID + "_upload").val("");
                    $("#" + theID + "_upload_path").val("");
                    $("#" + theID + "_upload_id").val(0);
                });

                // tab
                $('.group').hide();
                $('.group:first').show();
                $('.imwpf-form-nav li:first').addClass('current');
                $('.imwpf-form-nav li a').click(function(evt) {
                    var hide_submit = $(this).attr("data-hide-submit");

                    if (hide_submit == "1") {
                        $("#submit").hide();
                    } else {
                        $("#submit").show();
                    }

                    $('.imwpf-form-nav li').removeClass('current');
                    $(this).parent().addClass('current');
                    var clicked_group = $(this).attr('href');
                    $('.group').hide();
                    $(clicked_group).show();
                    evt.preventDefault();
                });

            });

            function ajaxRequest(url, callback) {
                jQuery.ajax({
                    url: url,
                    dataType: "json",
                    success: function(data) {
                        callback(data, true);
                    },
                    error: function(response, status, xhr) {
                        callback(xhr, false);
                    }
                });
            }

            // 递归请求
            function recursionRequest(url, resultContainer) {
                ajaxRequest(url, function(data, success) {
                    console.log(resultContainer.find(".running").remove());
                    if (!success) {
                        resultContainer.append("<p>请求失败！原因是: " + data + "</p>");
                        return;
                    }
                    if (data.hasOwnProperty("data")) {
                        resultContainer.append(data.data.content);
                        if (data.data.hasOwnProperty("log")) {
                            resultContainer.append(data.data.log);
                        }
                        if (data.data.next_url) {
                            recursionRequest(data.data.next_url, resultContainer);
                        }
                    } else if (data.hasOwnProperty("msg")) {
                        resultContainer.append(data.msg);
                    } else {
                        resultContainer.append(data);
                    }
                });
            }

            function requestOnce(url, resultContainer, recursion = false) {
                ajaxRequest(url, function(data, success) {
                    if (!success) {
                        resultContainer.append("<p>请求失败！原因是: " + data + "</p>");
                        return;
                    }
                    if (data.hasOwnProperty("data")) {
                        resultContainer.append(data.data.content);
                        if (data.data.hasOwnProperty("log")) {
                            resultContainer.append(data.data.log);
                        }
                        if (data.data.next_url && recursion) {
                            requestOnce(data.data.next_url, resultContainer);
                        }
                    } else if (data.hasOwnProperty("msg")) {
                        resultContainer.append(data.msg);
                    } else {
                        resultContainer.append(data);
                    }
                });
            }

            // 请求拼装成进度条样式
            function processBarRequest(url, resultContainer, logContainer) {
                var width = resultContainer.width();
                var processContent = resultContainer.find(".imwpf-process-content");
                if (processContent.width() == 0) {
                    processContent.animate({
                        "width": "2%"
                    }, 50);
                }

                ajaxRequest(url, function(data, success) {
                    if (!success) {
                        if (g_retry < 10) {
                            logContainer.html("请求失败,重试中,次数:" + g_retry);
                            processBarRequest(url, resultContainer, logContainer);
                            g_retry++;
                        } else {
                            g_retry = 0;
                            processContent.animate({
                                "width": "100%"
                            }, 50);
                        }
                        return;
                    }
                    // console.log(data.data.ratio);
                    if (data.hasOwnProperty("data")) {
                        var bar_ratio = data.data.ratio;
                        if (bar_ratio < 20) {
                            bar_ratio = 20;
                        }
                        processContent.animate({
                            "width": bar_ratio * width / 100
                        }, 50);
                        processContent.html(data.data.ratio + "%");
                        // 显示log信息
                        if (data.data.hasOwnProperty("log")) {
                            logContainer.html(data.data.log);
                        }
                        if (data.data.next_url) {
                            g_retry = 0;
                            processBarRequest(data.data.next_url, resultContainer, logContainer);
                        }
                    } else {
                        if (g_retry < 10) {
                            logContainer.html("请求失败,重试中,次数:" + g_retry);
                            processBarRequest(url, resultContainer, logContainer);
                            g_retry++;
                        } else {
                            g_retry = 0;
                            processContent.animate({
                                "width": "100%"
                            }, 50);
                        }
                    }
                });
            }
        </script>
<?php  } public function text($, $ = null, $ = null, $ = null, $ = false, $ = array()) { if (!$) { $ = $; } $this->input[] = array('type' => 'text', 'name' => $, 'value' => $, 'label' => $, 'desc' => $, 'is_hide' => $, 'show' => $); $this->currentInputIndex++; return $this; } public function num($, $ = null, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'num', 'name' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function interval($, $ = null, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'interval', 'name' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function replacer($, $ = null, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'replacer', 'name' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function twoColsText($, array $, $ = null, $ = null, $ = null) { if (!$) { $ = $; } if (count($) != 2) { throw new \Exception("参数错误，colLabel数组长度需要为2"); } $this->input[] = array('type' => 'twocols', 'name' => $, 'col_labels' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function textN($, array $, $ = null, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'textN', 'name' => $, 'col_labels' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function inputGroup($, $) { $this->input[] = array("type" => 'inputgroup', "name" => $, "value" => $); } public function textarea($, $ = null, $ = null, $ = null, $ = false) { if (!$) { $ = $; } $this->input[] = array('type' => 'textarea', 'name' => $, 'value' => $, 'label' => $, 'desc' => $, 'is_hide' => $); $this->currentInputIndex++; return $this; } public function color($, $, $, $ = null, $ = false) { $this->input[] = array('type' => 'color', 'name' => $, 'value' => $, 'label' => $, 'desc' => $, 'is_hide' => $); $this->currentInputIndex++; return $this; } public function datetime($, $ = null, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'datetime', 'name' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function multiCheck($, $, $, $ = null, $ = null) { if (!$) { $ = $; } if (empty($) || !is_array($)) { $ = array(); } $this->input[] = array('type' => 'multicheck', 'name' => $, 'options' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function check($, $, $, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'check', 'name' => $, 'option' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function select($, $, $, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'select', 'name' => $, 'options' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function label($, $ = null) { $this->input[] = array('type' => 'label', 'name' => $, 'value' => $); $this->currentInputIndex++; return $this; } public function info($, $, $) { $this->input[] = array('type' => 'info', 'name' => $, 'value' => $, 'label' => $); $this->currentInputIndex++; return $this; } public function tab($, $, $ = false) { $this->input[] = array('type' => 'tab', 'name' => $, 'value' => $, 'hide_submit' => $); $this->currentInputIndex++; return $this; } public function hidden($, $) { $this->input[] = array('type' => 'hidden', 'name' => $, 'value' => $); $this->currentInputIndex++; return $this; } public function toggle($, $, $ = null, $ = null, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'toggle', 'name' => $, 'option' => $, 'value' => $, 'desc' => $, 'label' => $); $this->currentInputIndex++; return $this; } public function multiToggle($, $ = array(), $ = null, $ = null, $ = null) { if (!$) { $ = $; } if (empty($) || !is_array($)) { $ = array(); } $this->input[] = array('type' => 'multitoggle', 'name' => $, 'options' => $, 'value' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function image($, $ = null, $ = null, $ = 0, $ = null) { if (!$) { $ = $; } $this->input[] = array('type' => 'image', 'name' => $, 'value' => $, 'path' => $, 'label' => $, 'attach_id' => $); $this->currentInputIndex++; return $this; } public function ajaxUpload($, $, $, $ = "", $ = "") { if (!$) { $ = $; } $this->input[] = array('type' => 'ajax_upload', 'name' => $, 'value' => $, 'path' => $, 'label' => $, 'desc' => $, 'upload_dir' => $); $this->currentInputIndex++; return $this; } public function upload($, $, $, $ = "") { if (!$) { $ = $; } $this->input[] = array('type' => 'upload', 'name' => $, 'value' => $, 'path' => $, 'label' => $, 'desc' => $); $this->currentInputIndex++; return $this; } public function request($, $, $, $ = "", $ = "") { $this->input[] = array('type' => 'request', 'name' => $, 'value' => $, 'button' => $, "label" => $, "desc" => $); $this->currentInputIndex++; return $this; } public function button($, $, $ = "", $ = "") { $this->input[] = array('type' => 'button', 'name' => $, 'value' => $, "label" => $, "desc" => $); $this->currentInputIndex++; return $this; } public function processBar($, $, $, $ = "", $ = "") { $this->input[] = array('type' => 'processbar', 'name' => $, 'value' => $, 'button' => $, "label" => $, "desc" => $); $this->currentInputIndex++; return $this; } public function clickSelect($, $, $, $, $ = "") { $this->input[] = array('type' => 'clickselect', 'name' => $, 'value' => $, 'options' => $, "label" => $, "desc" => $); $this->currentInputIndex++; return $this; } public function canAdd() { $this->input[$this->currentInputIndex]['add'] = true; return $this; } public function hide($) { $this->input[$this->currentInputIndex]['is_hide'] = true; $ = $this->input[$this->currentInputIndex]['name']; $this->showCondition[$] = $; return $this; } public function render($ = true) { $this->createScript(); $ = $this->getInput($); return "<form method='{$this->form['method']}' id='{$this->formID}' action='{$this->form['action']}' enctype='multipart/form-data' novalidate='novalidate'>{$}</form>"; } public function getInput($ = false, $ = false) { $ = "<div class='form-content'>"; $ = 0; $ = ""; $ = false; if (!$) { $ = $this->input; } foreach ($ as $) { $++; $['desc'] = !empty($['desc']) ? $['desc'] : ''; if (isset($['is_hide']) && $['is_hide'] == true) { $ = "imwp-hidden form-row"; } else { $ = "imwp-show form-row"; } switch ($['type']) { case 'text': case 'num': $ .= $this->getText($); break; case 'inputgroup': $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); $ .= "<div class=\"{$} clearfix\" id=\"{$}\"><h4>{$['name']}</h4>"; $ = $["value"]; $ .= "<div class='input-group'>"; if (empty($[0]["value"])) { $ .= $this->getInput(false, $["value"]) . '<div class="add">+</div>'; } else { $ = count($[0]["value"]); for ($ = 0; $ < $; $++) { $ = array(); foreach ($ as $) { $["value"] = $["value"][$]; $[] = $; } $ .= $this->getInput(false, $); if ($ > 0) { $ .= '<div class="minus">-</div>'; } } } $ .= '<div class="add">+</div></div></div>'; break; case 'textarea': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $['value'] = !empty($['value']) ? $['value'] : ''; $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); $ .= "<div class=\"{$} clearfix\" id=\"{$}\"><h4>{$['label']}</h4>"; $ .= "<div class=\"form-col\">\n                        <textarea class=\"regular-text\" name=\"{$['name']}\" rows=5>{$['value']}</textarea>\n                            {$['desc']}\n                        </div>\n                        </div>"; break; case 'datetime': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $['value'] = !empty($['value']) ? $['value'] : ''; $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); $ .= "<div class=\"{$} clearfix\" id=\"{$}\"><h4>{$['label']}</h4>"; $ .= "<div class=\"form-col\">\n                        <input class=\"regular-text\" name=\"{$['name']}\" value=\"{$['value']}\" type=\"datetime-local\" />\n                        {$['desc']}\n                        </div>\n                        </div>"; break; case 'toggle': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); $['value'] = !empty($['value']) ? $['value'] : ""; if (is_array($["option"])) { $ = $["option"][0]; $ = $["option"][1]; } else { $ = $["option"]; $ = $['label']; } $ .= '<div class="' . $ . ' clearfix" id="' . $ . '"><h4>' . $['label'] . '</h4>
                        <div class="form-col">'; if ($ == $['value']) { $ .= '<div class="mb10"><label><div class="imwpf-toggle"><input class="imwpf-toggle-input" type="checkbox" checked="checked" name="' . $['name'] . '" value="' . $ . '" >
                            <div class="imwpf-toggle-items">
                            <span class="imwpf-toggle-track"></span>
                            <span class="imwpf-toggle-thumb"></span>
                            <svg class="imwpf-toggle-off" width="6" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 6 6">
                                <path d="M3 1.5c.8 0 1.5.7 1.5 1.5S3.8 4.5 3 4.5 1.5 3.8 1.5 3 2.2 1.5 3 1.5M3 0C1.3 0 0 1.3 0 3s1.3 3 3 3 3-1.3 3-3-1.3-3-3-3z"></path>
                            </svg>
                            <svg class="imwpf-toggle-on" width="2" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 2 6">
                                <path d="M0 0h2v6H0z"></path>
                            </svg>
                        </div>
                        </div>
                        &nbsp;' . $ . '</label></div>'; } else { $ .= '<div class="mb10"><label><div class="imwpf-toggle">
                            <input class="imwpf-toggle-input" type="checkbox" name="' . $['name'] . '" value="' . $ . '" >
                            <div class="imwpf-toggle-items">
                            <span class="imwpf-toggle-track"></span>
                            <span class="imwpf-toggle-thumb"></span>
                            <svg class="imwpf-toggle-off" width="6" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 6 6">
                                <path d="M3 1.5c.8 0 1.5.7 1.5 1.5S3.8 4.5 3 4.5 1.5 3.8 1.5 3 2.2 1.5 3 1.5M3 0C1.3 0 0 1.3 0 3s1.3 3 3 3 3-1.3 3-3-1.3-3-3-3z"></path>
                            </svg>
                            <svg class="imwpf-toggle-on" width="2" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 2 6">
                                <path d="M0 0h2v6H0z"></path>
                            </svg>
                        </div>
                        </div>
                        &nbsp;' . $ . '</label></div>'; } $ .= $['desc'] . '</div>
                        </div>'; break; case 'multitoggle': $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); $['value'] = !empty($['value']) ? $['value'] : array(); $ .= '<div class="' . $ . ' clearfix" id="' . $ . '"><h4>' . $['label'] . '</h4>
                        <div class="form-col">'; foreach ($['options'] as $ => $) { if (in_array($, $['value'])) { $ .= '<div class="mb10"><label><div class="imwpf-toggle"><input class="imwpf-toggle-input" type="checkbox" checked="checked" name="' . $['name'] . '[]" value="' . $ . '" >
                            <div class="imwpf-toggle-items">
                            <span class="imwpf-toggle-track"></span>
                            <span class="imwpf-toggle-thumb"></span>
                            <svg class="imwpf-toggle-off" width="6" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 6 6">
                                <path d="M3 1.5c.8 0 1.5.7 1.5 1.5S3.8 4.5 3 4.5 1.5 3.8 1.5 3 2.2 1.5 3 1.5M3 0C1.3 0 0 1.3 0 3s1.3 3 3 3 3-1.3 3-3-1.3-3-3-3z"></path>
                            </svg>
                            <svg class="imwpf-toggle-on" width="2" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 2 6">
                                <path d="M0 0h2v6H0z"></path>
                            </svg>
                        </div>
                        </div>
                        &nbsp;' . $ . '</label></div>'; } else { $ .= '<div class="mb10"><label><div class="imwpf-toggle">
                            <input class="imwpf-toggle-input" type="checkbox" name="' . $['name'] . '[]" value="' . $ . '" >
                            <div class="imwpf-toggle-items">
                            <span class="imwpf-toggle-track"></span>
                            <span class="imwpf-toggle-thumb"></span>
                            <svg class="imwpf-toggle-off" width="6" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 6 6">
                                <path d="M3 1.5c.8 0 1.5.7 1.5 1.5S3.8 4.5 3 4.5 1.5 3.8 1.5 3 2.2 1.5 3 1.5M3 0C1.3 0 0 1.3 0 3s1.3 3 3 3 3-1.3 3-3-1.3-3-3-3z"></path>
                            </svg>
                            <svg class="imwpf-toggle-on" width="2" height="6" aria-hidden="true"
                                 role="img" focusable="false" viewBox="0 0 2 6">
                                <path d="M0 0h2v6H0z"></path>
                            </svg>
                        </div>
                        </div>
                        &nbsp;' . $ . '</label></div>'; } } $ .= '<p class="description">' . $['desc'] . '</p></div>
                        </div>'; break; case 'replacer': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $['value'] = !empty($['value']) ? $['value'] : array(array('12', '23')); $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ = count($['value']) - 1; $ = isset($['add']) ? '<span class="add" data-index="' . $ . '">+</span>' : ''; $ = isset($['add']) ? '<span class="minus">-</span>' : ''; $ .= "<div>"; foreach ($['value'] as $ => $) { $ .= "<div style=\"margin-top:5px;\"><input type=\"text\" name=\"{$['name']}[{$}][]\" value=\"{$[0]}\" />\n                         => <input type=\"text\" name=\"{$['name']}[{$}][]\" value=\"{$[1]}\" />"; if ($ == 0) { $ .= $; } else { $ .= $; } $ .= "</div>"; } $ .= "</div>"; $ .= "</div>"; break; case 'twocols': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $['value'] = !empty($['value']) ? $['value'] : array(array('', '')); $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ = count($['value']) - 1; $ = isset($['add']) ? '<span class="add" data-index="' . $ . '">+</span>' : ''; $ = isset($['add']) ? '<span class="minus">-</span>' : ''; $ .= "<div>"; foreach ($['value'] as $ => $) { $ .= "<div style=\"margin-bottom:10px;\">{$["col_labels"][0]}<input type=\"text\" name=\"{$['name']}[{$}][]\" value=\"{$[0]}\" />\n                        {$["col_labels"][1]} <input type=\"text\" name=\"{$['name']}[{$}][]\" value=\"{$[1]}\" />"; if ($ == 0) { $ .= $; } else { $ .= $; } $ .= "</div>"; } $ .= "<p>{$['desc']}</p></div>\n                    </div>"; break; case 'textN': $ = count($["col_labels"]); $['desc'] = !empty($['desc']) ? "<p class=\"description\">{$['desc']}</p>" : ""; $['value'] = !empty($['value']) ? $['value'] : array_fill(0, $, ''); $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4><div class='form-col'>"; $ .= "<div style='display:flex;'>"; foreach ($['value'] as $ => $) { $ .= '<label>' . $["col_labels"][$] . '<input style="width:50px; flex-shrink:0; margin:0px 10px 0px 5px" type="text" name="' . $['name'] . '[]" value="' . $ . '" /></label>'; } $ .= "</div>"; $ .= $['desc'] . '</div></div>'; break; case 'select': $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= "<div class=\"{$} clearfix\" id=\"{$}\"><h4>{$['label']}</h4>"; $ .= "<div class=\"form-col\"><select name=\"{$['name']}\">"; foreach ($['options'] as $ => $) { if ($['value'] == $) { $ .= "<option id=\"{$['name']}-{$}\" value=\"{$}\" selected=\"selected\">{$}</option>"; } else { $ .= "<option id=\"{$['name']}-{$}\" value=\"{$}\">{$}</option>"; } } $ .= "</select>{$['desc']}</div></div>"; break; case 'multiselect': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ .= "<div class=\"form-col\"><select name=\"{$['name']}\">"; foreach ($['options'] as $ => $) { if ($['value'] == $) { $ .= "<option id=\"{$['name']}-{$}\" value=\"{$}\" selected=\"selected\">{$}</option>"; } else { $ .= "<option id=\"{$['name']}-{$}\" value=\"{$}\">{$}</option>"; } } $ .= "</select>{$['desc']}</div></div>"; break; case 'multicheck': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ .= "<div class='form-col'>"; foreach ($['options'] as $ => $) { if (in_array($, $['value'])) { $ .= "<p><input id=\"{$['name']}-{$}\" name=\"{$['name']}[]\" type=\"checkbox\" checked=\"checked\" value=\"{$}\"><label for=\"{$['name']}-{$}\">{$}</label></p>"; } else { $ .= "<p><input id=\"{$['name']}-{$}\" name=\"{$['name']}[]\" type=\"checkbox\" value=\"{$}\"><label for=\"{$['name']}-{$}\">{$}</label></p>"; } } $ .= "{$['desc']}</div></div>"; break; case 'check': isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ .= "<div class=\"form-col\">"; if ($['value'] == $['option']) { $ = 'checked = "checked"'; } else { $ = ''; } $ .= "<p>\n                        <input id=\"{$['name']}\" name=\"{$['name']}\" type=\"checkbox\" {$} value=\"{$['option']}\">\n                        <label for=\"{$['name']}\">{$['label']}</label>\n                    </p>"; $ .= "{$['desc']}</div></div>"; break; case 'image': $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $["name"]); $ .= "<div class=\"{$} clearfix\" id=\"{$}\"><h4>{$['label']}</h4><div class='form-col'>"; isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= $this->uploader($['name'], $['value'], $["path"], $["attach_id"]) . '</div></div>'; break; case 'ajax_upload': $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= "<div class=\"form-col\">"; $ .= '<input name="' . $["name"] . '" id="' . $["name"] . '_upload" type="hidden" value="' . $["value"] . '" />'; $ .= '<input name="' . $["name"] . '_path" id="' . $["name"] . '_upload_path" type="hidden" value="' . $["value"] . '" />'; $ .= '<div class="upload_button_div"><span class="button imwpf_image_upload_button" id="' . $["name"] . '_upload_button" data-upload-dir="' . $["upload_dir"] . '">上传</span>'; if (!empty($)) { $ = ''; } else { $ = 'hide'; } $ .= '<span class="button imwpf_image_reset_button ' . $ . '" id="reset_' . $["name"] . '" title="' . $["name"] . '">移除</span>'; $ .= "{$['desc']}</div></div></div>"; break; case 'upload': $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; isset($['desc']) ? $['desc'] = "<p class=\"description\">{$['desc']}</p>" : $['desc'] == ''; $ .= "<div class=\"form-col\">"; $ .= "<input type=\"file\" name=\"{$['name']}\" id=\"{$['name']}\" value=\"{$["value"]}\">"; $ .= "{$['desc']}</div></div>"; break; case 'hidden': $ .= "<input name=\"{$['name']}\" type=\"hidden\" value=\"{$['value']}\">"; break; case 'label': $ .= "<div class=\"{$} clearfix\"><h4>{$['name']}</h4><div class=\"form-col\">{$['value']}</div></div>"; break; case 'info': $ .= "<div id=\"{$['name']}\" class=\"{$} clearfix\"><h4>{$['label']}</h4><div class=\"form-col\">{$['value']}</div></div>"; break; case 'interval': $ .= $this->($); break; case 'tab': $ = true; if ($ >= 2) { $ .= '</div>' . "\n"; } $ = preg_replace("/[^A-Za-z0-9]/", "", strtolower($['name'])); $ = "imwpf-click-" . $; $ .= '<li><a title="' . $['value'] . '" href="#' . $ . '" data-hide-submit="' . $['hide_submit'] . '">' . $['value'] . '</a></li>'; $ .= '<div class="group" id="' . $ . '"><h2>' . $['value'] . '</h2>' . "\n"; break; case 'request': $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ .= '<div class="form-col">
                        <a id="' . $['name'] . '" class="button-primary">' . $['button'] . '</a>
                    <p class="description">' . $['desc'] . '</p>
                    <div id="result-' . $['name'] . '"></div>
                    <script type="text/javascript">
                        jQuery(document).ready(function($) {
                            $("#' . $['name'] . '").click(function(){
                                var resultContainer = $("#result-' . $['name'] . '");
                                resultContainer.html("<p class=\\"running\\">执行中，请不要关闭页面...</p>");
                                recursionRequest(ajaxurl + "' . $['value'] . '", resultContainer);
                            });
                        });
                    </script></div></div>'; break; case 'button': $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ .= '<div class="form-col">
                        <a id="button-' . $['name'] . '" class="button-primary">' . $['value'] . '</a>
                        <div id="button-' . $['name'] . '-result"></div>
                        <p class="description">' . $['desc'] . '</p>
                        </div></div>
                        '; break; case "clickselect": $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4><div class=\"form-col\">"; $ .= '<div id="' . $["name"] . '" class="click-select-container">'; $ .= '<div class="selected clearfix"></div>'; $ .= '<div class="select-list clearfix">'; foreach ($['options'] as $ => $) { $ .= '<span class="click-select" data-name="' . $["name"] . '[]" data-value="' . $ . '">' . $ . '</span>'; } $ .= "</div>"; $ .= '<script type="text/javascript">
                    jQuery(document).ready(function($) {
                        clickSelect();
                        initClickSelect(' . json_encode($["value"], true) . ', "#' . $["name"] . '");
                    })</script>'; $ .= "</div><!--end container-->"; $ .= "</div></div>"; break; case 'color': $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4><div class=\"form-col\">"; $ .= '<input name="' . $['name'] . '" id="' . $['name'] . '" type="text" class="regular-text" value="' . $['value'] . '" />'; $ .= '<div id="' . $['name'] . '_picker" class="color-selector"><div style="background-color: ' . $['value'] . '"></div></div>'; $ .= '<p class="description">' . $['desc'] . '</p>'; $ .= "</div></div>"; break; case 'processbar': $ .= "<div class=\"{$} clearfix\"><h4>{$['label']}</h4>"; $ .= '
                    <div class="form-col">
                        <a id="' . $['name'] . '" class="button-primary">' . $['button'] . '</a>
                        <a id="' . $['name'] . '-reset" class="button-primary">重置进度</a>
                        <div class="imwpf-process-bar" id="processbar-' . $['name'] . '">
                            <div class="imwpf-process-content"></div>
                        </div>
                        <div class="imwpf-log-content" id="result-' . $['name'] . '"></div>
                        <div class="imwpf-process-log-content" id="processbar-log-' . $['name'] . '"></div>
                        <p class="description">' . $["desc"] . '</p>
                    </div>
                    <script type="text/javascript">
                        jQuery(document).ready(function($) {
                            $("#' . $['name'] . '").click(function(){
                                if(!confirm("确定要执行?")) {
                                    return false;
                                }
                                $("#result-' . $['name'] . '").fadeOut(100);
                                var resultContainer = $("#processbar-' . $['name'] . '");
                                var logContainer = $("#processbar-log-' . $['name'] . '");
                                resultContainer.fadeIn(100);
                                logContainer.fadeIn(100);
                                processBarRequest(ajaxurl + "' . $['value'] . '", resultContainer, logContainer);
                            });
                            $("#' . $['name'] . '-reset").click(function(){
                                if(!confirm("是否重置进度?")) {
                                    return false;
                                }
                                resultContainer = $("#processbar-' . $['name'] . '").fadeOut(100)
                                logContainer = $("#processbar-log-' . $['name'] . '").fadeOut(100);
                                var resultContainer = $("#result-' . $['name'] . '");
                                resultContainer.fadeIn(100);
                                resultContainer.html("<p>执行中，请不要关闭页面...</p>");
                                requestOnce(ajaxurl + "' . $['value'] . '&reset=1", resultContainer, false);
                            });
                        });
                    </script></div>'; break; } } if (function_exists("wp_create_nonce")) { $ .= '<input type="hidden" id="security" name="security" value="' . wp_create_nonce('imwpf_upload_nonce') . '" />'; } $ .= '</div>'; if ($) { $ = isset($this->form['submit']) ? $this->form['submit'] : '提交'; if (!empty($)) { $ .= "<p class='submit'><input type='submit' name='submit' id='submit' class='button button-primary' value='{$}'></p>"; } } if ($) { $ .= "</div>"; } $ .= $this->(); if (!empty($)) { if (!empty($this->_minHeight)) { $ = 'style="min-height:' . $this->_minHeight . '"'; } return '<div class="imwpf-form-wrap clearfix">
                        <div class="imwpf-form-container clearfix">
                            <div class="imwpf-form-nav"><ul>' . $ . '</ul>
                        </div>
                        <div class="content" ' . $ . '>' . $ . '</div>
                        </div>
                    </div>'; } return '<div class="imwpf-form-wrap clearfix"><div class="imwpf-form-container clearfix">
                    <div class="content content-long">' . $ . '</div>
                </div></div>'; } public function getText($) { $ = $['name']; $['value'] = isset($['value']) ? $['value'] : ''; $['desc'] = isset($['desc']) ? $['desc'] : ''; if (isset($['is_hide']) && $['is_hide'] == true) { $ = "imwp-hidden form-row"; } else { $ = "imwp-show form-row"; } $ = ""; $ = ""; $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $); if (is_array($['value'])) { $ = "<div class=\"{$} clearfix\" id=\"{$}\"><h4>\n            <label>{$['label']}</label>\n            </h4>\n            <div class='form-col'>"; foreach ($['value'] as $ => $) { if ($ > 0) { $ = '<span class="minus">-</span>'; $ .= "<br/>"; } $ .= "<input class=\"regular-text\" type=\"text\" name=\"{$}\" value=\"{$}\">{$}"; } $ .= "<span class=\"add\">+</span><p class=\"description\">{$['desc']}</p></div></div>"; } else { $ = isset($['add']) ? '<span class="add">+</span>' : ''; $ = "<div class=\"{$} clearfix\" id=\"{$}\">\n                    <h4><label>{$['label']}</label></h4>\n                    <div class=\"form-col\">\n                        <input class=\"regular-text\" type=\"text\" name=\"{$}\" value=\"{$['value']}\">\n                        {$}\n                        <p class=\"description\">{$['desc']}</p>\n                        </div>\n                    </div>"; } if (!empty($['show'])) { $ = $['show']['key']; $ = json_encode($['show']['value']); $ = <<<EOF
<script>
jQuery("input[name='{$}'],select[name='{$}']").change(function(){
    var arr = {$}
    value = jQuery(this).val();
    if (arr.indexOf(value) != -1) {
        if (jQuery("#{$}").hasClass("form-row")) {
            jQuery("#{$}").css("display", "flex");
        } else {
            jQuery("#{$}").show();
        }
    } else {
        jQuery("#{$}").hide();
    }
});
jQuery(document).ready(function(){
    var arr = {$};
    value = jQuery("input[name='{$}'], select[name='{$}']").val();
    if (arr.indexOf(value) != -1) {
        if (jQuery("#{$}").hasClass("form-row")) {
            jQuery("#{$}").css("display", "flex");
        } else {
            jQuery("#{$}").show();
        }
    } else {
        jQuery("#{$}").hide();
    }
});

</script>
EOF;
} return $ . $; } public static function uploader($, $, $, $) { $ = '<input name="' . $ . '" id="' . $ . '_upload" type="hidden" value="' . $ . '" />'; $ .= '<input name="' . $ . '_path" id="' . $ . '_upload_path" type="hidden" value="' . $ . '" />'; $ .= '<input name="' . $ . '_id" id="' . $ . '_upload_id" type="hidden" value="' . $ . '" />'; $ .= '<div class="upload_button_div"><span class="button imwpf_image_upload_button" id="' . $ . '_upload_button" file-id="' . $ . '">上传图片</span>'; if (!empty($)) { $ = ''; } else { $ = 'hide'; } $ .= '<span class="button imwpf_image_reset_button ' . $ . '" id="' . $ . '_reset_button" title="' . $ . '">移除</span></div>'; $ .= '<div class="clear"></div>'; if (!empty($)) { $ .= '<img class="uploaded-image" id="image_' . $ . '" src="' . $ . '" />'; } return $; } private function () { $ = "<script>"; foreach ($this->showCondition as $ => $) { foreach ($ as $ => $) { $ = preg_replace("/([^a-zA-Z_\\-]+)/", "", $); $ = json_encode($); $ .= "imwpf_condition_show('{$}', '{$}', {$});"; } } $ .= "</script>"; return $; } private function ($) { if (isset($['desc'])) { $['desc'] = "<p class=\"description\">{$['desc']}</p>"; } else { $['desc'] == ''; } $['value'] = !empty($['value']) ? intval($['value']) : ''; if (isset($['is_hide']) && $['is_hide'] == true) { $ = "imwp-hidden form-row"; } else { $ = "imwp-show form-row"; } $ = "<div class=\"{$} clearfix\" id=\"{$["name"]}\"><h4>{$['label']}</h4>"; $ = array(); for ($ = 0; $ <= 10; $++) { $[$] = $ . "年"; } $ = array(); for ($ = 0; $ < 12; $++) { $[$] = $ . "月"; } $ = array(); for ($ = 0; $ < 30; $++) { $[$] = $ . "天"; } $ = array(); for ($ = 0; $ < 24; $++) { $[$] = $ . "小时"; } $ = array(); for ($ = 0; $ < 60; $++) { $[$] = $ . "分"; } $ = array(); for ($ = 0; $ < 60; $++) { $[$] = $ . "秒"; } $ = utils\Time::getComponent($["value"]); $ .= "<div class='form-col'>"; $ .= $this->makeSelect($["name"] . "-year", $, $["year"]); $ .= $this->makeSelect($["name"] . "-month", $, $["month"]); $ .= $this->makeSelect($["name"] . "-day", $, $["day"]); $ .= $this->makeSelect($["name"] . "-hour", $, $["hour"]); $ .= $this->makeSelect($["name"] . "-minutes", $, $["minutes"]); $ .= $this->makeSelect($["name"] . "-seconds", $, $["seconds"]); $ .= "{$['desc']}</div></div>"; return $; } public function makeSelect($, $, $) { $ = " <select name=\"{$}\">"; foreach ($ as $ => $) { if ($ == $) { $ .= "<option id=\"{$}-{$}\" value=\"{$}\" selected=\"selected\">\n                    <label for=\"{$}-{$}\">{$}</option>"; } else { $ .= "<option id=\"{$}-{$}\" value=\"{$}\"><label for=\"{$}-{$}\">{$}</label></option>"; } } $ .= "</select> "; return $; } public function getInputData() { return $this->input; } public function setInputData($) { $this->input = $; } public function saveSubmit($) { if (empty($_POST)) { return; } $this->input = $this->($); $->save(); } private function ($, $ = null) { $ = array("processbar", "tab", "info", "label", "button", "request"); if (!$) { $ = $this->input; } foreach ($ as &$) { if (in_array($["type"], $)) { continue; } $ = array("multitoggle", "clickselect", "multicheck"); $ = ""; if (strpos($["name"], "[]") !== false) { $ = str_replace("[]", "", $["name"]); $ = Input::arr($); $->add($, $); } else { if (in_array($["type"], $)) { $ = Input::arr($["name"]); $->add($["name"], $); } else { if ($["type"] == "interval") { $ = Input::interval($["name"]); $->add($["name"], $); } else { if ($["type"] == "num") { $ = Input::int($["name"]); $->add($["name"], $); } else { if ($["type"] == "inputgroup") { $ = $this->($, $["value"]); } else { if ($["type"] == "image") { $ = Input::str($["name"]); $ = Input::str($["name"] . "_path"); $ = Input::str($["name"] . "_id"); $->add($["name"], $); $->add($["name"] . "_path", $); $->add($["name"] . "_id", $); $["path"] = $; $["attach_id"] = $; } else { $ = Input::str($["name"]); $->add($["name"], $); } } } } } } $["value"] = $; } return $this->($); } private function ($) { if (is_array($)) { foreach ($ as $ => $) { $[$] = $this->($); } return $; } else { if (is_string($)) { return stripslashes($); } } return $; } }