<?php
 namespace imwpf\modules; use imwpf\modules\Options; use imwpf\modules\Input; use imwpf\modules\Form; use imwpf\modules\utils\Message; use imwpf\modules\ui\Window; use imwpf\modules\wp\API; use imwpf\modules\http\CURLHTTP; class Proxy { private $_app; public function __construct($) { $this->_app = $; } public static function registerChecker($) { API::addOnlyAdmin($ . "_check_proxy", function () use($) { if (empty(Input::str("proxy"))) { die("参数错误"); } $ = Options::getInstance($ . "_proxy"); $ = Input::str('proxy'); $ = parse_url($); $ = Input::str("check_url", "http://www.baidu.com"); $ = CURLHTTP::get($, 30); $->setProxy($)->exec(); $ = $->getResponseHeader(); if (!empty($) && $["code"] == 200) { $->add($["host"], array("ip" => $["host"], "scheme" => $["scheme"], "port" => $["port"], "username" => $["user"], "password" => $["pass"], "check_url" => $, "is_valid" => 1))->save(); die("有效"); } else { $->add($["host"], array("ip" => $["host"], "scheme" => $["scheme"], "port" => $["port"], "username" => $["user"], "password" => $["pass"], "check_url" => $, "is_valid" => -1))->save(); die("无效"); } die; }); } public function adminUI() { $ = Input::str("action"); if ($ == "add") { $this->(); return; } $ = Options::getInstance($this->_app . "_proxy"); if ($ == "delete") { $ = Input::str("ip"); $->delete($)->save(); echo Message::success("删除成功"); Window::replaceURL(admin_url("admin.php?page=" . $this->_app . "&__tab=proxy")); } $ = '<p>
            <a href="?page=' . $this->_app . '&__tab=proxy&action=add" class="button">添加代理</a>
            <a class="button" id="check-proxy">验证当前新增代理</a>
            <a class="button" id="check-invalid-proxy">验证当前无效代理</a>
            <a class="button" id="check-valid-proxy">验证当前有效代理</a>
        </p>'; $ = $->getAll(); $ .= '<table id="common-proxy" class="wp-list-table widefat fixed striped">
        <thead><tr>
            <th>类型</th>
            <th>地址</th>
            <th>端口</th>
            <th>用户名</th>
            <th>密码</th>
            <th>是否有效</th>
            <th>操作</th>
        </tr></thead>'; foreach ($ as $ => $) { $ = $["is_valid"]; $ = self::toString($); $ = $["check_url"]; $ .= "<tr class=\"proxy-{$}\" data-checker=\"{$this->_app}_check_proxy\" data-proxy=\"{$}\" data-check-url=\"{$}\">"; $ .= "<td>{$['scheme']}</td><td>{$['ip']}</td><td>{$['port']}</td><td>{$['username']}</td><td>{$['password']}</td>"; if ($ == "0") { $ .= "<td class=\"status\">未验证</td>"; } else { if ($ == "1") { $ .= "<td class=\"status\">有效</td>"; } else { if ($ == "-1") { $ .= "<td class=\"status\">无效</td>"; } } } $ = admin_url("admin.php?page=" . $this->_app . "&__tab=proxy&action=delete&ip=" . $); $ .= "<td><a class=\"imwpf-confirm\" data-href=\"{$}\">删除</a></td></tr>"; } $ .= '</table>'; $this->(); echo $; } private function () { if (!empty($_POST)) { $ = Options::getInstance($this->_app . "_proxy"); $ = Input::str("ip"); $ = Input::str("port"); $ = Input::str("scheme"); $ = Input::str("username"); $ = Input::str("password"); $ = Input::str("check_url"); $ = array("ip" => $, "port" => $, "username" => $, "password" => $, "scheme" => $, "check_url" => $, "is_valid" => 0); $->add($, $)->save(); echo Message::success("添加成功"); } $ = new Form(); $->select("scheme", array("socks5" => "SOCKS5", "socks4" => "SOCKS4", "http" => "HTTP"), "", "代理类型")->text("ip", "", "IP")->text("port", "", "端口")->text("username", "", "用户名")->text("password", "", "密码")->text("check_url", "http://www.baidu.com", "检查地址"); echo $->render(); } public static function getOne($) { $ = Options::getInstance($ . "_proxy"); $ = $->getAll(); foreach ($ as $ => $) { if ($["is_valid"] != "1") { unset($[$]); } } if (empty($)) { return ""; } $ = array_values($); if (empty($)) { return ""; } $ = rand(0, count($) - 1); return self::toString($[$]); } public static function toString($) { if (!empty($["username"])) { $ = $["scheme"] . "://" . $["username"] . ":" . $["password"] . "@" . $["ip"] . ":" . $["port"]; } else { $ = $["scheme"] . "://" . $["ip"] . ":" . $["port"]; } return $; } private function () { echo <<<EOF
<script>
function checkProxy(className){var times=0;jQuery("#common-proxy tr"+className).each((function(){var proxy=jQuery(this).attr("data-proxy"),checker=jQuery(this).attr("data-checker"),check_url=jQuery(this).attr("data-check-url");if(proxy){var statusDom=jQuery(this).find(".status");setTimeout((function(){statusDom.text("验证中..."),jQuery.get(ajaxurl+"?action="+checker+"&proxy="+encodeURIComponent(proxy)+"&check_url="+encodeURIComponent(check_url),(function(result){statusDom.text(result)}))}),1500*times),times++}}))}jQuery(document).ready((function(\$){jQuery("#check-proxy").click((function(){checkProxy(".proxy-0")})),jQuery("#check-valid-proxy").click((function(){checkProxy(".proxy-1")})),jQuery("#check-invalid-proxy").click((function(){checkProxy(".proxy--1")}))}));</script>
EOF;
} }